#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <termios.h>
#include <sys/ioctl.h>

#include "cons.h"
#include <fcntl.h>

static struct termios tattr, saved_attributes;
static int LastNap = -1;

int LINES=0, COLS=0;

int getch(void)
{
	int a, temp = 0;
	if(LastNap >= 0)
	{
		temp = LastNap;
		LastNap = -1;
		return temp;
	}
	a = fcntl(STDIN_FILENO,F_GETFL);
	fcntl(STDIN_FILENO, F_SETFL, a & ~O_NONBLOCK);
	fread(&temp, 1, 1, stdin);
	fcntl(STDIN_FILENO, F_SETFL, a);
	return temp;
}

int kbhit(void) 
{
	unsigned char Byte;
	if(LastNap >= 0)return 1;
	if(fread(&Byte, 1, 1, stdin))
	{
		LastNap = Byte;
		return 1;
	}
	LastNap = -1;
	return 0;
}

void DoneCons(void)
{
	tcsetattr(STDIN_FILENO, TCSAFLUSH, &saved_attributes);
}

void InitCons(void)
{ 
	struct winsize ws;        /* buffer for TIOCSWINSZ */
  
	if(ioctl(STDOUT_FILENO, TIOCGWINSZ, &ws) >= 0)
	{
		LINES = ws.ws_row;
		COLS  = ws.ws_col;
	}
	if(LINES==0 || COLS==0)
	{
		printf("Unknown window sizes (%d, %d), setting to 80x25\n",COLS,LINES);
		LINES=25;
		COLS=80;
	}

	setvbuf(stdout, NULL, _IONBF, 0);

    tcgetattr(STDIN_FILENO, &saved_attributes);
    tcgetattr(STDIN_FILENO, &tattr);
    tattr.c_lflag &= ~(ICANON|ECHO);
    tattr.c_cc[VMIN] = 1;
    tattr.c_cc[VTIME] = 0;
    tcsetattr(STDIN_FILENO, TCSAFLUSH, &tattr);
	fcntl(STDIN_FILENO,F_SETFL,fcntl(STDIN_FILENO,F_GETFL)|O_NONBLOCK);
}
